Index: base/applications/cmdutils/eventcreate/eventcreate.rc
===================================================================
--- base/applications/cmdutils/eventcreate/eventcreate.rc	(revision 72865)
+++ base/applications/cmdutils/eventcreate/eventcreate.rc	(working copy)
@@ -21,3 +21,6 @@
 #ifdef LANGUAGE_FR_FR
     #include "lang/fr-FR.rc"
 #endif
+#ifdef LANGUAGE_RU_RU
+    #include "lang/ru-RU.rc"
+#endif
Index: base/applications/cmdutils/eventcreate/lang/ru-RU.rc
===================================================================
--- base/applications/cmdutils/eventcreate/lang/ru-RU.rc	(nonexistent)
+++ base/applications/cmdutils/eventcreate/lang/ru-RU.rc	(working copy)
@@ -0,0 +1,68 @@
+LANGUAGE LANG_RUSSIAN, SUBLANG_DEFAULT
+
+STRINGTABLE
+BEGIN
+    IDS_USAGE "Введите ""EVENTCREATE /?"" для получения справки по использованию.\n"
+    IDS_HELP "\n\
+EVENTCREATE [/S система [/U [домен\\]пользователь [/P пароль]]] /ID код_события\n\
+            {[/L имя_журнала] | [/SO источник]} /T тип /C категория /D описание\n\
+\n\
+Описание:\n\
+    Эта команда позволяет администратору создать запись об особом событии \n\
+    в указанном журнале событий.\n\
+\n\
+Список параметров:\n\
+    /S  система           Определяет удаленную систему для подключения.\n\
+\n\
+    /U  [домен\\]польз.    Определяет контекст пользователя, под которым\n\
+                          выполняется данная команда.\n\
+\n\
+    /P  [пароль]          Задает пароль для данного контекста пользователя.\n\
+                          Запрашивает ввод пароля, если он не был задан.\n\
+\n\
+    /L  журнал            Журнал в котором будет создано событие.\n\
+                          Доступными именами являются:\n\
+                          Application, System, Security\n\
+                          (последний зарезервирован только для учетной записи SYSTEM).\n\
+\n\
+    /SO источник          Задает имя источника, используемого для события\n\
+                          (если не указано, то по умолчанию имя источника\n\
+                          будет 'eventcreate').\n\
+                          Допустимым источником является любая строка, представляющая\n\
+                          приложение или компонент, который генерирует\n\
+                          событие.\n\
+\n\
+    /T  тип               Тип создаваемого события.\n\
+                          Допустимыми типами являются: SUCCESS, ERROR, WARNING,\n\
+                          INFORMATION.\n\
+\n\
+    /C  категория         Определяет категорию события (число) для события.\n\
+\n\
+    /ID код_события       Код события для этого события. Допустимым кодом\n\
+                          является число в диапазоне от 1 до 1000.\n\
+\n\
+    /D  описание          Описание для создаваемого события.\n\
+\n\
+    /?                    Показать эту справку.\n\
+"
+    IDS_INVALIDSWITCH "Неправильный параметр или аргумент - '%s'.\n"
+    IDS_BADSYNTAX_0 "Синтаксическая ошибка.\n"
+    IDS_BADSYNTAX_1 "Синтаксическая ошибка. Для параметра '%s' должно быть указано значение.\n"
+    IDS_BADSYNTAX_2 "Синтаксическая ошибка. Значение опции '%s' не может быть пустым.\n"
+    IDS_BADSYNTAX_3 "Синтаксическая ошибка. Значение '%s' является недопустимым для опции '%s'.\n"
+    IDS_BADSYNTAX_4 "Синтаксическая ошибка. Для опции '%s' не может быть указано значение.\n"
+    IDS_BADSYNTAX_5 "Синтаксическая ошибка. Опция '%s' не допускается более чем %lu раз.\n"
+    IDS_BADSYNTAX_6 "Синтаксическая ошибка. Отсутствует обязательный параметр '%s'.\n"
+    // IDS_BADSYNTAX_7 "Синтаксическая ошибка. Значение для опции '%s' за пределами разрешенного диапазона.\n"
+    IDS_BADSYNTAX_7 "Синтаксическая ошибка. Значение для опции '%s' должно быть в диапазоне от %d до %d.\n"
+
+    IDS_LOG_NOT_FOUND "Журнал '%s' не существует. Не удалось создать событие.\n"
+    IDS_SOURCE_NOCREATE "Новый источник не может быть создан, поскольку имя журнала не указано.\nИспользуйте параметр /L чтобы указать имя журнала.\n"
+    IDS_SOURCE_EXISTS "Источник уже существует в журнале '%s' и не может быть продублирован.\n"
+    IDS_SOURCE_NOT_CUSTOM "Параметр Источник используется для идентификации сценариев/программ\пользовательских приложений (не установленных приложений).\n"
+
+    IDS_SUCCESS_1   "Операция выполнена успешно: событие с типом '%s' было успешно создано в журнале '%s'.\n"
+    IDS_SUCCESS_2   "Операция выполнена успешно: событие с типом '%s' было успешно создано с источником '%s'.\n"
+    IDS_SUCCESS_3   "Операция выполнена успешно: событие с типом '%s' было успешно создано\nв журнале '%s' с источником '%s'.\n"
+    IDS_SWITCH_UNIMPLEMENTED "Опция '%s' не поддерживается, приносим извинения за возможное неудобство!\n"
+END
Index: base/applications/network/ping/lang/ru-RU.rc
===================================================================
--- base/applications/network/ping/lang/ru-RU.rc	(revision 72891)
+++ base/applications/network/ping/lang/ru-RU.rc	(working copy)
@@ -59,7 +59,7 @@
     Пакетов: отправлено = %2!d!, получено = %3!d!, потеряно %4!d! (%5!u!%% потерь),\n"
 
     IDS_APPROXIMATE_RTT "Приблизительное время приема-передачи в мс:\n\
-    Минимальное = %1!u!ms, Максимальное = %2!u!ms, Среднее = %3!u!ms\n"
+    Минимальное = %1!u!мс, Максимальное = %2!u!мс, Среднее = %3!u!мс\n"
 
     IDS_WINSOCK_FAIL "Не удалось инициализировать WinSock: %1!d!\n"
 END