Index: base/applications/mscutils/eventvwr/lang/ru-RU.rc
===================================================================
--- base/applications/mscutils/eventvwr/lang/ru-RU.rc	(revision 72960)
+++ base/applications/mscutils/eventvwr/lang/ru-RU.rc	(working copy)
@@ -99,7 +99,7 @@
     EDITTEXT IDC_DISPLAYNAME, 67, 7, 178, 12, ES_LEFT | ES_AUTOHSCROLL | WS_CHILD | WS_VISIBLE | WS_BORDER | WS_TABSTOP
     LTEXT "&Имя журнала:", IDC_STATIC, 7, 25, 60, 8
     EDITTEXT IDC_LOGNAME, 67, 23, 178, 12, ES_LEFT | ES_AUTOHSCROLL | ES_READONLY | WS_CHILD | WS_VISIBLE | WS_BORDER | WS_TABSTOP
-    LTEXT "Файл &журана:", IDC_STATIC, 7, 41, 60, 8
+    LTEXT "Файл &журнала:", IDC_STATIC, 7, 41, 60, 8
     EDITTEXT IDC_LOGFILE, 67, 39, 178, 12, ES_LEFT | ES_AUTOHSCROLL | ES_READONLY | WS_CHILD | WS_VISIBLE | WS_BORDER | WS_TABSTOP
     LTEXT "Размер:", IDC_STATIC, 7, 57, 60, 8
     EDITTEXT IDC_SIZE_LABEL, 67, 57, 178, 12, ES_LEFT | ES_READONLY | NOT WS_BORDER | NOT WS_TABSTOP | ES_AUTOHSCROLL
Index: base/shell/explorer/lang/ru-RU.rc
===================================================================
--- base/shell/explorer/lang/ru-RU.rc	(revision 72960)
+++ base/shell/explorer/lang/ru-RU.rc	(working copy)
@@ -73,17 +73,17 @@
     CONTROL "", IDC_TASKBARPROP_TASKBARBITMAP, "Static", SS_BITMAP | SS_SUNKEN, 13, 18, 224, 21
     AUTOCHECKBOX "&Закрепить панель задач", IDC_TASKBARPROP_LOCK, 13, 45, 200, 10
     AUTOCHECKBOX "&Автоматически скрывать панель задач", IDC_TASKBARPROP_HIDE, 13, 58, 200, 10
-    AUTOCHECKBOX "&Поверх других окон", IDC_TASKBARPROP_ONTOP, 13, 71, 200, 10
-    AUTOCHECKBOX "&Группировать схожие кнопки", IDC_TASKBARPROP_GROUP, 13, 84, 200, 10
+    AUTOCHECKBOX "Отображать панель задач &поверх других окон", IDC_TASKBARPROP_ONTOP, 13, 71, 200, 10
+    AUTOCHECKBOX "&Группировать схожие кнопки панели задач", IDC_TASKBARPROP_GROUP, 13, 84, 200, 10
     AUTOCHECKBOX "Отображать панель &быстрого запуска", IDC_TASKBARPROP_SHOWQL, 13, 97, 200, 10
-    GROUPBOX "Панель уведомлений", IDC_STATIC, 6, 114, 240, 98
+    GROUPBOX "Область уведомлений", IDC_STATIC, 6, 114, 240, 98
     CONTROL "", IDC_TASKBARPROP_NOTIFICATIONBITMAP, "Static", SS_BITMAP | SS_SUNKEN,13, 126, 223, 28
-    AUTOCHECKBOX "&Часы", IDC_TASKBARPROP_CLOCK, 13, 153, 80, 10
-    AUTOCHECKBOX "Отображать секунды", IDC_TASKBARPROP_SECONDS, 120, 153, 80, 10, WS_DISABLED
+    AUTOCHECKBOX "Отображать &часы", IDC_TASKBARPROP_CLOCK, 13, 153, 80, 10
+    AUTOCHECKBOX "Отображать &секунды", IDC_TASKBARPROP_SECONDS, 120, 153, 83, 10, WS_DISABLED
     LTEXT "Можно избежать загромождения области уведомлений, скрывая значки, которые давно не использовались.", IDC_STATIC, 13, 169, 223, 16
-    AUTOCHECKBOX "&Скрывать неиспользуемые значки", IDC_TASKBARPROP_HIDEICONS, 13, 191, 125, 10
+    AUTOCHECKBOX "Скрывать &неиспользуемые значки", IDC_TASKBARPROP_HIDEICONS, 13, 191, 128, 10
     PUSHBUTTON "&Настроить...", IDC_TASKBARPROP_ICONCUST, 188, 191, 50, 14
-END 
+END
 
 IDD_TASKBARPROP_STARTMENU DIALOGEX 0, 0, 252, 218
 STYLE DS_SHELLFONT | DS_MODALFRAME | WS_POPUP | WS_VISIBLE | WS_CAPTION | WS_SYSMENU
@@ -109,7 +109,7 @@
     LTEXT            "Выберите элемент и измените его поведение:", IDC_STATIC, 6, 40, 220, 10
     CONTROL          "", IDC_NOTIFICATION_LIST, "SysListView32", WS_CLIPSIBLINGS | WS_BORDER | 0x00008005, 6, 50, 220, 128
     COMBOBOX         IDC_NOTIFICATION_BEHAVIOUR, 103, 178, 78, 200, CBS_DROPDOWNLIST | NOT WS_VISIBLE | WS_CLIPSIBLINGS
-    PUSHBUTTON       "&По умолчанию", IDC_TASKBARPROP_NOTIREST, 164, 188, 62, 14
+    PUSHBUTTON       "&Восстановить по умолчанию", IDC_TASKBARPROP_NOTIREST, 115, 188, 110, 14
     DEFPUSHBUTTON    "OK", IDOK, 122, 220, 50, 14
     PUSHBUTTON       "Отмена", IDCANCEL, 176, 220, 50, 14
 END
@@ -116,7 +116,7 @@
 
 IDD_CLASSICSTART_CUSTOMIZE DIALOGEX 0, 0, 232, 240, 0
 STYLE DS_SETFONT | DS_MODALFRAME | DS_FIXEDSYS | DS_CONTEXTHELP | WS_POPUPWINDOW | WS_VISIBLE | WS_DLGFRAME
-CAPTION "Настройка классическог меню ""Пуск"""
+CAPTION "Настройка классического меню ""Пуск"""
 FONT 8, "MS Shell Dlg"
 {
     GROUPBOX         "Меню ""Пуск""", IDC_STATIC, 8, 7, 218, 114
@@ -124,11 +124,11 @@
     LTEXT            "Вы можете настроить меню ""Пуск"" путем добавления или удаления элементов.", IDC_STATIC, 48, 17, 108, 39
     PUSHBUTTON       "&Добавить...", IDC_CLASSICSTART_ADD, 162, 18, 53, 14
     PUSHBUTTON       "&Удалить...", IDC_CLASSICSTART_REMOVE, 162, 33, 53, 14
-    PUSHBUTTON       "Д&ополнительно", IDC_CLASSICSTART_ADVANCED, 162, 49, 53, 14
+    PUSHBUTTON       "&Вручную", IDC_CLASSICSTART_ADVANCED, 162, 49, 53, 14
     PUSHBUTTON       "&Сортировать", IDC_CLASSICSTART_SORT, 162, 65, 53, 14
     ICON             IDI_RECYCLEBIN, IDC_STATIC, 20, 85, 20, 20
     LTEXT            "Для удаления записей о недавних документах, программах и сайтах нажмите ""Очистить"".", IDC_STATIC, 49, 85, 108, 33
-    PUSHBUTTON       "&Очистить", IDC_CLASSICSTART_CLEAR, 162, 94, 53, 14
+    PUSHBUTTON       "О&чистить", IDC_CLASSICSTART_CLEAR, 162, 94, 53, 14
     LTEXT            "До&полнительные параметры меню ""Пуск"":", IDC_STATIC, 8, 129, 150, 8
     CONTROL          "StartMenuSe&ttings", IDC_CLASSICSTART_SETTINGS, "SysTreeView32", WS_BORDER | 0x00000001, 8, 139, 218, 72, WS_EX_CLIENTEDGE
     DEFPUSHBUTTON    "OK", IDOK, 122, 220, 50, 14
@@ -156,7 +156,7 @@
     GROUPBOX         "Параметры меню ""Пуск"" ", IDC_STATIC, 7, 7, 238, 42
     AUTOCHECKBOX     "&Открывать подменю при задержке на них мыши", IDC_AUTOOPEN, 14, 21, 224, 10
     AUTOCHECKBOX     "&Подсвечивать недавно установленные программы", IDC_HIGHLIGHT, 14, 35, 224, 10
-    LTEXT            "Элементы меню ""Пуск"":", IDC_STATIC, 7, 53, 238, 8
+    LTEXT            "&Элементы меню ""Пуск"":", IDC_STATIC, 7, 53, 238, 8
     CONTROL          "StartMenuSe&ttings", IDC_ITEMS, "SysTreeView32", WS_BORDER | 0x00000001, 7, 63, 238, 67, WS_EX_CLIENTEDGE
     GROUPBOX         "Недавние документы ", IDC_STATIC, 7, 133, 238, 56
     LTEXT            "Выберите эту опцию для обеспечения быстрого доступа к недавним документам. Очистка этого списка не удаляет документы.", IDC_STATIC, 14, 144, 224, 21
@@ -176,10 +176,10 @@
     AUTORADIOBUTTON  "&Маленькие значки", IDC_CHOOSESMALL, 177, 25, 51, 10, NOT WS_TABSTOP
     GROUPBOX         "Программы ", IDC_STATIC, 7, 49, 238, 70
     LTEXT            "Меню ""Пуск"" содержит ярлыки программ, которые вы часто используете. Очистка списка не удаляет программы.", IDC_STATIC, 14, 63, 224, 20
-    LTEXT            "&Количество программ в меню ""Пуск"":", IDC_STATIC, 14, 86, 112, 8
+    LTEXT            "К&оличество программ в меню ""Пуск"":", IDC_STATIC, 14, 86, 112, 8
     EDITTEXT         IDC_NUMBEROFPROGRAMS, 133, 84, 27, 12, ES_LEFT | ES_RIGHT | ES_NUMBER
     CONTROL          "", IDC_NUMBERUPDOWN, "msctls_updown32", WS_BORDER | 0x000000B6, 160, 84, 11, 12
-    PUSHBUTTON       "&Очистить список", IDC_CLEARLIST, 182, 98, 57, 14
+    PUSHBUTTON       "О&чистить список", IDC_CLEARLIST, 182, 98, 57, 14
     GROUPBOX         "Показывать в меню ""Пуск"" ", IDC_STATIC, 7, 126, 238, 63
     AUTOCHECKBOX     "&Интернет:", IDC_SHOWINTERNET, 14, 140, 42, 10
     COMBOBOX         IDC_INTERNETDEFAULTAPP, 98, 138, 140, 200, CBS_DROPDOWNLIST | WS_VSCROLL
@@ -198,5 +198,5 @@
 
 STRINGTABLE
 BEGIN
-    IDS_TASKBAR_STARTMENU_PROP_CAPTION "Свойства меню ""Пуск"" и панели задач"
+    IDS_TASKBAR_STARTMENU_PROP_CAPTION "Меню ""Пуск"" и панель задач"
 END
Index: dll/win32/shell32/lang/ru-RU.rc
===================================================================
--- dll/win32/shell32/lang/ru-RU.rc	(revision 72960)
+++ dll/win32/shell32/lang/ru-RU.rc	(working copy)
@@ -21,7 +21,7 @@
 BEGIN
     POPUP ""
     BEGIN
-        POPUP "&Просмотр", FCIDM_SHVIEW_VIEW
+        POPUP "&Вид", FCIDM_SHVIEW_VIEW
         BEGIN
             MENUITEM "&Большие значки", FCIDM_SHVIEW_BIGICON
             MENUITEM "&Мелкие значки", FCIDM_SHVIEW_SMALLICON