Index: base/shell/explorer/explorer.rc
===================================================================
--- base/shell/explorer/explorer.rc	(revision 73564)
+++ base/shell/explorer/explorer.rc	(working copy)
@@ -160,3 +160,6 @@
 #ifdef LANGUAGE_ZH_TW
     #include "lang/zh-TW.rc"
 #endif
+#ifdef LANGUAGE_MO_MD_CYRL
+    #include "lang/mo-MD-Cyrl.rc"
+#endif
Index: base/shell/explorer/lang/mo-MD-Cyrl.rc
===================================================================
--- base/shell/explorer/lang/mo-MD-Cyrl.rc	(nonexistent)
+++ base/shell/explorer/lang/mo-MD-Cyrl.rc	(working copy)
@@ -0,0 +1,206 @@
+/*
+ * FILE:       base/shell/explorer/lang/mo-MD-Cyrl.rc
+ * PURPOSE:    Moldovan Cyrillic Language File for ReactOS Explorer
+ * TRANSLATOR: cybernenea11 (cybernenea11 [at] yandex [dot] com)
+ */
+
+LANGUAGE LANG_MOLDOVAN, SUBLANG_MOLDOVAN_CYRILLIC
+
+IDM_TRAYWND MENU
+BEGIN
+    POPUP ""
+    BEGIN
+        MENUITEM SEPARATOR
+        MENUITEM "&Регларя Датей/Орей", ID_SHELL_CMD_ADJUST_DAT
+        MENUITEM "&Регларя нотификэрилор...", ID_SHELL_CMD_CUST_NOTIF
+        MENUITEM SEPARATOR
+        MENUITEM "Аранжэрь ын каска&дэ", ID_SHELL_CMD_CASCADE_WND
+        MENUITEM "Аранжэрь &оризонтале", ID_SHELL_CMD_TILE_WND_H
+        MENUITEM "Аранжэрь &вертикале", ID_SHELL_CMD_TILE_WND_V
+        MENUITEM "Афишаре &спациу де лукру", ID_SHELL_CMD_SHOW_DESKTOP
+        MENUITEM "&Ануларе", ID_SHELL_CMD_UNDO_ACTION
+        MENUITEM SEPARATOR
+        MENUITEM "&Диспечер де сарчинь", ID_SHELL_CMD_OPEN_TASKMGR
+        MENUITEM SEPARATOR
+        MENUITEM "Фи&ксаря паноулуй де сарчинь", ID_LOCKTASKBAR
+        MENUITEM "П&роприетэць", ID_SHELL_CMD_PROPERTIES
+    END
+END
+
+IDM_STARTMENU MENUEX
+BEGIN
+    POPUP ""
+    BEGIN
+        MENUITEM "", -1, MFT_SEPARATOR
+        POPUP "&Програме", IDM_PROGRAMS
+        BEGIN
+            MENUITEM "(Гол)", -1, MFT_STRING, MFS_GRAYED
+        END
+        POPUP "&Фаворите", IDM_FAVORITES
+        BEGIN
+            MENUITEM "(Гол)", -1, MFT_STRING, MFS_GRAYED
+        END
+        POPUP "&Документе", IDM_DOCUMENTS
+        BEGIN
+            MENUITEM "(Гол)", -1, MFT_STRING, MFS_GRAYED
+        END
+        POPUP "Р&егларе", IDM_SETTINGS
+        BEGIN
+            MENUITEM "Паноул де &контрол", IDM_CONTROLPANEL, MFT_STRING, MFS_GRAYED
+            MENUITEM "", -1, MFT_SEPARATOR
+            MENUITEM "С&екуритате...", IDM_SECURITY, MFT_STRING, MFS_ENABLED
+            MENUITEM "Конексиунь ла &реця", IDM_NETWORKCONNECTIONS, MFT_STRING, MFS_ENABLED
+            MENUITEM "И&мприманте ши факсурь", IDM_PRINTERSANDFAXES, MFT_STRING, MFS_ENABLED
+            MENUITEM "&Паноул де сарчинь ши мениул принчипал", IDM_TASKBARANDSTARTMENU, MFT_STRING, MFS_ENABLED
+        END
+        POPUP "Кэут&аре", IDM_SEARCH
+        BEGIN
+            MENUITEM "", -1, MFT_SEPARATOR
+        END
+        MENUITEM "&Информаций", IDM_HELPANDSUPPORT, MFT_STRING, MFS_ENABLED
+        MENUITEM "Е&кзекутаре...", IDM_RUN, MFT_STRING, MFS_ENABLED
+        MENUITEM "", 450, MFT_SEPARATOR, MFS_ENABLED
+        MENUITEM "Синк&ронизаре", IDM_SYNCHRONIZE, MFT_STRING, MFS_ENABLED
+        MENUITEM "Ын&кеере сесиуний %s...", IDM_LOGOFF, MFT_STRING, MFS_ENABLED
+        MENUITEM "Де&конектаре...", IDM_DISCONNECT, MFT_STRING, MFS_ENABLED
+        MENUITEM "Б&локаре", IDM_UNDOCKCOMPUTER, MFT_STRING, MFS_ENABLED
+        MENUITEM "С&тинӂере...", IDM_SHUTDOWN, MFT_STRING, MFS_ENABLED
+    END
+END
+
+IDD_TASKBARPROP_TASKBAR DIALOGEX 0, 0, 252, 218
+STYLE DS_SHELLFONT | DS_MODALFRAME | WS_POPUP | WS_VISIBLE | WS_CAPTION | WS_SYSMENU
+CAPTION "Паноул де сарчинь"
+FONT 8, "MS Shell Dlg", 0, 0, 0x1
+BEGIN
+    GROUPBOX "Аспектул паноулуй де сарчинь", IDC_STATIC, 6, 6, 240, 104
+    CONTROL "", IDC_TASKBARPROP_TASKBARBITMAP, "Static", SS_BITMAP | SS_SUNKEN, 13, 18, 224, 21
+    AUTOCHECKBOX "Фи&ксаря паноулуй де сарчинь", IDC_TASKBARPROP_LOCK, 13, 45, 200, 10
+    AUTOCHECKBOX "&Ауто-аскундеря паноулуй де сарчинь", IDC_TASKBARPROP_HIDE, 13, 58, 200, 10
+    AUTOCHECKBOX "&Менцинеря паноулуй де сарчинь деасупра челорлалте ферестре", IDC_TASKBARPROP_ONTOP, 13, 71, 200, 10
+    AUTOCHECKBOX "&Групаря бутоанелор симиларе дин паноул де сарчинь", IDC_TASKBARPROP_GROUP, 13, 84, 200, 10
+    AUTOCHECKBOX "Афишаря паноулуй де &лансэрь рапиде", IDC_TASKBARPROP_SHOWQL, 13, 97, 200, 10
+    GROUPBOX "Зона де нотификаре", IDC_STATIC, 6, 114, 240, 98
+    CONTROL "", IDC_TASKBARPROP_NOTIFICATIONBITMAP, "Static", SS_BITMAP | SS_SUNKEN,13, 126, 223, 28
+    AUTOCHECKBOX "Афишаря &часулуй", IDC_TASKBARPROP_CLOCK, 13, 153, 80, 10
+    AUTOCHECKBOX "Афишаря с&екунделор", IDC_TASKBARPROP_SECONDS, 120, 153, 83, 10, WS_DISABLED
+    LTEXT "Путець евита агломераря ын зона де нотификаре прин аскундеря пиктограмелор, каре ну ау фост утилизате речент.", IDC_STATIC, 13, 169, 223, 16
+    AUTOCHECKBOX "Аск&ундеря пиктограмелор неутилизате", IDC_TASKBARPROP_HIDEICONS, 13, 191, 128, 10
+    PUSHBUTTON "&Регларе...", IDC_TASKBARPROP_ICONCUST, 188, 191, 50, 14
+END
+
+IDD_TASKBARPROP_STARTMENU DIALOGEX 0, 0, 252, 218
+STYLE DS_SHELLFONT | DS_MODALFRAME | WS_POPUP | WS_VISIBLE | WS_CAPTION | WS_SYSMENU
+CAPTION "Мениул принчипал"
+FONT 8, "MS Shell Dlg", 0, 0, 0x1
+BEGIN
+    CONTROL "", IDC_TASKBARPROP_STARTMENU_BITMAP, "Static", SS_BITMAP | SS_SUNKEN,7, 7, 183, 108
+    AUTORADIOBUTTON "Мениул &принчипал", IDC_TASKBARPROP_STARTMENU, 7, 135, 105, 10, WS_DISABLED
+    LTEXT "Ачест стил де мениу оферэ акчес комод ла мапе, програмеле фаворите ши кэутаре.", IDC_STATIC, 20, 145, 150, 24, WS_DISABLED
+    PUSHBUTTON "Р&егларе...", IDC_TASKBARPROP_STARTMENUCUST, 192, 132, 53, 14, WS_DISABLED
+    AUTORADIOBUTTON "Мениул принчипал &класик", IDC_TASKBARPROP_STARTMENUCLASSIC, 7, 175, 105, 10
+    LTEXT "Ачест стил де мениу оферэ аспектул ши функционалитатя класикэ.", IDC_STATIC, 20, 185, 150, 24
+    PUSHBUTTON "Ре&гларе...", IDC_TASKBARPROP_STARTMENUCLASSICCUST, 192, 172, 53, 14
+END
+
+IDD_NOTIFICATIONS_CUSTOMIZE DIALOGEX 0, 0, 232, 240
+STYLE DS_SETFONT | DS_MODALFRAME | DS_FIXEDSYS | DS_CONTEXTHELP | WS_POPUPWINDOW | WS_VISIBLE | WS_DLGFRAME
+EXSTYLE WS_EX_CONTEXTHELP
+CAPTION "Регларя нотификэрилор"
+FONT 8, "MS Shell Dlg"
+BEGIN
+    LTEXT            "ReactOS афишязэ пиктограме пентру нотификэрь активе ши урӂенте, дар ле аскунде пе челе инактиве. Путець скимба ачест компортамент пентру елементеле дин листа де май жос.", IDC_STATIC, 6, 6, 220, 30
+    LTEXT            "Селектаць ун елемент, апой алеӂець компортаментул луй:", IDC_STATIC, 6, 40, 220, 10
+    CONTROL          "", IDC_NOTIFICATION_LIST, "SysListView32", WS_CLIPSIBLINGS | WS_BORDER | 0x00008005, 6, 50, 220, 128
+    COMBOBOX         IDC_NOTIFICATION_BEHAVIOUR, 103, 178, 78, 200, CBS_DROPDOWNLIST | NOT WS_VISIBLE | WS_CLIPSIBLINGS
+    PUSHBUTTON       "&Ревенире ла инициале", IDC_TASKBARPROP_NOTIREST, 115, 188, 110, 14
+    DEFPUSHBUTTON    "Конфирм", IDOK, 122, 220, 50, 14
+    PUSHBUTTON       "Ревокаре", IDCANCEL, 176, 220, 50, 14
+END
+
+IDD_CLASSICSTART_CUSTOMIZE DIALOGEX 0, 0, 232, 240, 0
+STYLE DS_SETFONT | DS_MODALFRAME | DS_FIXEDSYS | DS_CONTEXTHELP | WS_POPUPWINDOW | WS_VISIBLE | WS_DLGFRAME
+CAPTION "Регларя мениулуй принчипал класик"
+FONT 8, "MS Shell Dlg"
+{
+    GROUPBOX         "Мениул принчипал", IDC_STATIC, 8, 7, 218, 114
+    ICON             IDI_STARTMENU2, IDC_STATIC, 19, 17, 20, 20
+    LTEXT            "Путець модифика мениул принчипал прин адэугаря сау елиминаря де елементе.", IDC_STATIC, 48, 17, 108, 39
+    PUSHBUTTON       "А&дэугаре...", IDC_CLASSICSTART_ADD, 162, 18, 53, 14
+    PUSHBUTTON       "&Елиминаре...", IDC_CLASSICSTART_REMOVE, 162, 33, 53, 14
+    PUSHBUTTON       "А&вансате", IDC_CLASSICSTART_ADVANCED, 162, 49, 53, 14
+    PUSHBUTTON       "&Сортаре", IDC_CLASSICSTART_SORT, 162, 65, 53, 14
+    ICON             IDI_RECYCLEBIN, IDC_STATIC, 20, 85, 20, 20
+    LTEXT            "Пентру а елимина ынреӂистрэрь але документелор, програмелор ши сайтурилор речент акчесате, апэсаць Курэцире.", IDC_STATIC, 49, 85, 108, 33
+    PUSHBUTTON       "&Курэцире", IDC_CLASSICSTART_CLEAR, 162, 94, 53, 14
+    LTEXT            "Опциунь ав&ансате але мениулуй принчипал:", IDC_STATIC, 8, 129, 150, 8
+    CONTROL          "StartMenuSe&ttings", IDC_CLASSICSTART_SETTINGS, "SysTreeView32", WS_BORDER | 0x00000001, 8, 139, 218, 72, WS_EX_CLIENTEDGE
+    DEFPUSHBUTTON    "Конфирм", IDOK, 122, 220, 50, 14
+    PUSHBUTTON       "Ревокаре", IDCANCEL, 176, 220, 50, 14
+}
+
+IDD_FILENAME_WARNING DIALOGEX 0, 0, 272, 81, 0
+STYLE DS_SETFONT | DS_MODALFRAME | DS_FIXEDSYS | DS_CENTER | WS_POPUPWINDOW | WS_DLGFRAME
+CAPTION "Авертизаре деспре денумиря фишиерулуй"
+FONT 8, "MS Shell Dlg"
+{
+    DEFPUSHBUTTON    "Игн&ораре", IDIGNORE, 215, 60, 50, 14
+    PUSHBUTTON       "&Реденумире", IDC_FILE_RENAME, 159, 60, 50, 14
+    LTEXT            "", IDC_STATIC, 7, 51, 258, 1, NOT WS_GROUP
+    AUTOCHECKBOX     "Н&у ефектуа ачастэ верификаре ла порнире", IDC_NOTCHECK, 7, 62, 139, 10
+    ICON             32515, IDC_STATIC, 7, 7, 21, 20
+    LTEXT            "Ын компутатор екзистэ ун фишиер сау о мапэ нумитэ %s, каре поате кауза проблеме ын функционаря коректэ а анумитор програме. Реденумиря са ын %s ар резолва ачастэ проблемэ. Реденумире акум?", IDC_STATIC, 34, 7, 224, 37
+}
+
+IDD_MODERNSTART_ADVANCED DIALOGEX 0, 0, 251, 198, 0
+STYLE DS_SETFONT | WS_CAPTION | WS_CHILD | WS_DISABLED
+CAPTION "Авансате"
+FONT 8, "MS Shell Dlg"
+{
+    GROUPBOX         "Опциунь але мениулуй принчипал ", IDC_STATIC, 7, 7, 238, 42
+    AUTOCHECKBOX     "&Дескидеря субмениурилор ла оприря индикаторулуй шоричелулуй деасупра лор", IDC_AUTOOPEN, 14, 21, 224, 10
+    AUTOCHECKBOX     "&Евиденциеря програмелор речент инсталате", IDC_HIGHLIGHT, 14, 35, 224, 10
+    LTEXT            "Елементе але &мениулуй принчипал:", IDC_STATIC, 7, 53, 238, 8
+    CONTROL          "StartMenuSe&ttings", IDC_ITEMS, "SysTreeView32", WS_BORDER | 0x00000001, 7, 63, 238, 67, WS_EX_CLIENTEDGE
+    GROUPBOX         "Документе реченте ", IDC_STATIC, 7, 133, 238, 56
+    LTEXT            "Селектаць ачастэ опциуне пентру а офери ун акчес рапид ла документеле речент акчесате. Курэцаря ачестей листе ну ва штерӂе документеле.", IDC_STATIC, 14, 144, 224, 21
+    AUTOCHECKBOX     "Афишаря документелор дескисе &речент", IDC_RECENTLY, 14, 168, 147, 10
+    PUSHBUTTON       "&Курэцире", IDC_CLEAR, 182, 168, 55, 14
+}
+
+IDD_MODERNSTART_GENERAL DIALOGEX 0, 0, 251, 198
+STYLE DS_SETFONT | DS_MODALFRAME | WS_POPUPWINDOW | WS_DLGFRAME
+CAPTION "Есенциале"
+FONT 8, "MS Shell Dlg"
+{
+    GROUPBOX         "Селектаць о дименсиуне де пиктограмэ пентру програме ", IDC_STATIC, 7, 7, 238, 37
+    ICON             IDC_LARGEICON, 17, 18, 20, 20, SS_CENTERIMAGE
+    ICON             IDC_SMALLICON, 151, 18, 20, 20, SS_CENTERIMAGE
+    AUTORADIOBUTTON  "Пиктограме м&арь", IDC_CHOOSELARGE, 43, 25, 53, 10
+    AUTORADIOBUTTON  "Пиктограме &мичь", IDC_CHOOSESMALL, 177, 25, 51, 10, NOT WS_TABSTOP
+    GROUPBOX         "Програме ", IDC_STATIC, 7, 49, 238, 70
+    LTEXT            "Мениул принчипал концине скуртэтурь ла програмеле челе май утилизате. Курэцаря ачестей листе ну ва штерӂе документеле.", IDC_STATIC, 14, 63, 224, 20
+    LTEXT            "Н&умэрул де програме ын мениул принчипал:", IDC_STATIC, 14, 86, 112, 8
+    EDITTEXT         IDC_NUMBEROFPROGRAMS, 133, 84, 27, 12, ES_LEFT | ES_RIGHT | ES_NUMBER
+    CONTROL          "", IDC_NUMBERUPDOWN, "msctls_updown32", WS_BORDER | 0x000000B6, 160, 84, 11, 12
+    PUSHBUTTON       "&Курэцире", IDC_CLEARLIST, 182, 98, 57, 14
+    GROUPBOX         "Афишаре ын мениул принчипал ", IDC_STATIC, 7, 126, 238, 63
+    AUTOCHECKBOX     "&Интернет:", IDC_SHOWINTERNET, 14, 140, 42, 10
+    COMBOBOX         IDC_INTERNETDEFAULTAPP, 98, 138, 140, 200, CBS_DROPDOWNLIST | WS_VSCROLL
+    AUTOCHECKBOX     "&Пошта електроникэ:", IDC_SHOWEMAIL, 14, 157, 37, 10
+    COMBOBOX         IDC_EMAILDEFAULTAPP, 98, 155, 140, 200, CBS_DROPDOWNLIST | WS_VSCROLL
+}
+
+STRINGTABLE
+BEGIN
+    IDS_START "Мениул"
+    IDS_PROPERTIES "П&роприетэць"
+    IDS_OPEN_ALL_USERS "&Тоць утилизаторий"
+    IDS_EXPLORE_ALL_USERS "Е&ксплораря утилизаторилор"
+    IDS_STARTUP_ERROR "Порниря експлораторулуй а ешуат дин кауза информациилор липсэ сау корупте дин реӂистру."
+END
+
+STRINGTABLE
+BEGIN
+    IDS_TASKBAR_STARTMENU_PROP_CAPTION "Паноул де сарчинь ши мениул принчипал"
+END