Index: dll/win32/devmgr/devmgmt/MainWindow.cpp
===================================================================
--- dll/win32/devmgr/devmgmt/MainWindow.cpp	(revision 73580)
+++ dll/win32/devmgr/devmgmt/MainWindow.cpp	(working copy)
@@ -494,6 +494,12 @@
     {
         case TVN_SELCHANGED:
         {
+            HMENU hMenu=GetSubMenu(m_hMenu, 1);
+            for(INT i=GetMenuItemCount(hMenu)-1;i>=0;i--)
+            {
+                DeleteMenu(hMenu, i, MF_BYPOSITION);
+            }
+            m_DeviceView->CreateActionMenu(hMenu, true);
             UpdateToolbar();
             break;
         }
Index: dll/win32/devmgr/lang/bg-BG.rc
===================================================================
--- dll/win32/devmgr/lang/bg-BG.rc	(revision 73580)
+++ dll/win32/devmgr/lang/bg-BG.rc	(working copy)
@@ -249,7 +249,11 @@
   BEGIN
     MENUITEM "E&xit",                       IDC_EXIT
   END
-  MENUITEM "Action",                        IDC_ACTIONMENU
+  POPUP "Action"
+  BEGIN
+    MENUITEM "Scan for hardware changes",   IDC_SCAN_HARDWARE
+    MENUITEM "Add hardware",                IDC_ADD_HARDWARE
+  END
   POPUP "View"
   BEGIN
     MENUITEM "Devices by type",             IDC_DEVBYTYPE
Index: dll/win32/devmgr/lang/cs-CZ.rc
===================================================================
--- dll/win32/devmgr/lang/cs-CZ.rc	(revision 73580)
+++ dll/win32/devmgr/lang/cs-CZ.rc	(working copy)
@@ -253,7 +253,11 @@
   BEGIN
     MENUITEM "E&xit",                       IDC_EXIT
   END
-  MENUITEM "Action",                        IDC_ACTIONMENU
+  POPUP "Action"
+  BEGIN
+    MENUITEM "Scan for hardware changes",   IDC_SCAN_HARDWARE
+    MENUITEM "Add hardware",                IDC_ADD_HARDWARE
+  END
   POPUP "View"
   BEGIN
     MENUITEM "Devices by type",             IDC_DEVBYTYPE
Index: dll/win32/devmgr/lang/de-DE.rc
===================================================================
--- dll/win32/devmgr/lang/de-DE.rc	(revision 73580)
+++ dll/win32/devmgr/lang/de-DE.rc	(working copy)
@@ -250,7 +250,11 @@
   BEGIN
     MENUITEM "&Beenden",                       IDC_EXIT
   END
-  MENUITEM "Ak&tion",                          IDC_ACTIONMENU
+  POPUP "Ak&tion"
+  BEGIN
+    MENUITEM "Nach geänderter Hardware suchen", IDC_SCAN_HARDWARE
+    MENUITEM "Hardware hinzufügen",             IDC_ADD_HARDWARE
+  END
   POPUP "&Ansicht"
   BEGIN
     MENUITEM "Geräte nach &Typ",               IDC_DEVBYTYPE
Index: dll/win32/devmgr/lang/el-GR.rc
===================================================================
--- dll/win32/devmgr/lang/el-GR.rc	(revision 73580)
+++ dll/win32/devmgr/lang/el-GR.rc	(working copy)
@@ -250,7 +250,11 @@
   BEGIN
     MENUITEM "E&xit",                       IDC_EXIT
   END
-  MENUITEM "Action",                        IDC_ACTIONMENU
+  POPUP "Action"
+  BEGIN
+    MENUITEM "Scan for hardware changes",   IDC_SCAN_HARDWARE
+    MENUITEM "Add hardware",                IDC_ADD_HARDWARE
+  END
   POPUP "View"
   BEGIN
     MENUITEM "Devices by type",             IDC_DEVBYTYPE
Index: dll/win32/devmgr/lang/en-US.rc
===================================================================
--- dll/win32/devmgr/lang/en-US.rc	(revision 73580)
+++ dll/win32/devmgr/lang/en-US.rc	(working copy)
@@ -247,7 +247,11 @@
   BEGIN
     MENUITEM "E&xit",                       IDC_EXIT
   END
-  MENUITEM "&Action",                        IDC_ACTIONMENU
+  POPUP "&Action"
+  BEGIN
+    MENUITEM "Scan for hardware changes",   IDC_SCAN_HARDWARE
+    MENUITEM "Add hardware",                IDC_ADD_HARDWARE
+  END
   POPUP "&View"
   BEGIN
     MENUITEM "D&evices by type",             IDC_DEVBYTYPE
Index: dll/win32/devmgr/lang/es-ES.rc
===================================================================
--- dll/win32/devmgr/lang/es-ES.rc	(revision 73580)
+++ dll/win32/devmgr/lang/es-ES.rc	(working copy)
@@ -250,7 +250,11 @@
   BEGIN
     MENUITEM "&Salir",                       IDC_EXIT
   END
-  MENUITEM "Acción",                         IDC_ACTIONMENU
+  POPUP "Acción"
+  BEGIN
+    MENUITEM "Buscar cambios de hardware",   IDC_SCAN_HARDWARE
+    MENUITEM "Añadir dispositivos",          IDC_ADD_HARDWARE
+  END
   POPUP "Ver"
   BEGIN
     MENUITEM "Dispositivos por tipo",        IDC_DEVBYTYPE
Index: dll/win32/devmgr/lang/fr-FR.rc
===================================================================
--- dll/win32/devmgr/lang/fr-FR.rc	(revision 73580)
+++ dll/win32/devmgr/lang/fr-FR.rc	(working copy)
@@ -249,7 +249,11 @@
   BEGIN
     MENUITEM "E&xit",                       IDC_EXIT
   END
-  MENUITEM "Action",                        IDC_ACTIONMENU
+  POPUP "Action"
+  BEGIN
+    MENUITEM "Scan for hardware changes",   IDC_SCAN_HARDWARE
+    MENUITEM "Add hardware",                IDC_ADD_HARDWARE
+  END
   POPUP "View"
   BEGIN
     MENUITEM "Devices by type",             IDC_DEVBYTYPE
Index: dll/win32/devmgr/lang/he-IL.rc
===================================================================
--- dll/win32/devmgr/lang/he-IL.rc	(revision 73580)
+++ dll/win32/devmgr/lang/he-IL.rc	(working copy)
@@ -250,7 +250,11 @@
   BEGIN
     MENUITEM "E&xit",                       IDC_EXIT
   END
-  MENUITEM "Action",                        IDC_ACTIONMENU
+  POPUP "Action"
+  BEGIN
+    MENUITEM "Scan for hardware changes",   IDC_SCAN_HARDWARE
+    MENUITEM "Add hardware",                IDC_ADD_HARDWARE
+  END
   POPUP "View"
   BEGIN
     MENUITEM "Devices by type",             IDC_DEVBYTYPE
Index: dll/win32/devmgr/lang/hu-HU.rc
===================================================================
--- dll/win32/devmgr/lang/hu-HU.rc	(revision 73580)
+++ dll/win32/devmgr/lang/hu-HU.rc	(working copy)
@@ -249,7 +249,11 @@
   BEGIN
     MENUITEM "E&xit",                       IDC_EXIT
   END
-  MENUITEM "Action",                        IDC_ACTIONMENU
+  POPUP "Action"
+  BEGIN
+    MENUITEM "Scan for hardware changes",   IDC_SCAN_HARDWARE
+    MENUITEM "Add hardware",                IDC_ADD_HARDWARE
+  END
   POPUP "View"
   BEGIN
     MENUITEM "Devices by type",             IDC_DEVBYTYPE
Index: dll/win32/devmgr/lang/id-ID.rc
===================================================================
--- dll/win32/devmgr/lang/id-ID.rc	(revision 73580)
+++ dll/win32/devmgr/lang/id-ID.rc	(working copy)
@@ -250,7 +250,11 @@
   BEGIN
     MENUITEM "E&xit",                       IDC_EXIT
   END
-  MENUITEM "Action",                        IDC_ACTIONMENU
+  POPUP "Action"
+  BEGIN
+    MENUITEM "Scan for hardware changes",   IDC_SCAN_HARDWARE
+    MENUITEM "Add hardware",                IDC_ADD_HARDWARE
+  END
   POPUP "View"
   BEGIN
     MENUITEM "Devices by type",             IDC_DEVBYTYPE
Index: dll/win32/devmgr/lang/it-IT.rc
===================================================================
--- dll/win32/devmgr/lang/it-IT.rc	(revision 73580)
+++ dll/win32/devmgr/lang/it-IT.rc	(working copy)
@@ -251,7 +251,11 @@
   BEGIN
     MENUITEM "E&xit",                       IDC_EXIT
   END
-  MENUITEM "Action",                        IDC_ACTIONMENU
+  POPUP "Action"
+  BEGIN
+    MENUITEM "Scan for hardware changes",   IDC_SCAN_HARDWARE
+    MENUITEM "Add hardware",                IDC_ADD_HARDWARE
+  END
   POPUP "View"
   BEGIN
     MENUITEM "Devices by type",             IDC_DEVBYTYPE
Index: dll/win32/devmgr/lang/no-NO.rc
===================================================================
--- dll/win32/devmgr/lang/no-NO.rc	(revision 73580)
+++ dll/win32/devmgr/lang/no-NO.rc	(working copy)
@@ -251,7 +251,11 @@
   BEGIN
     MENUITEM "E&xit",                       IDC_EXIT
   END
-  MENUITEM "Action",                        IDC_ACTIONMENU
+  POPUP "Action"
+  BEGIN
+    MENUITEM "Scan for hardware changes",   IDC_SCAN_HARDWARE
+    MENUITEM "Add hardware",                IDC_ADD_HARDWARE
+  END
   POPUP "View"
   BEGIN
     MENUITEM "Devices by type",             IDC_DEVBYTYPE
Index: dll/win32/devmgr/lang/pl-PL.rc
===================================================================
--- dll/win32/devmgr/lang/pl-PL.rc	(revision 73580)
+++ dll/win32/devmgr/lang/pl-PL.rc	(working copy)
@@ -259,7 +259,11 @@
   BEGIN
     MENUITEM "E&xit",                       IDC_EXIT
   END
-  MENUITEM "Action",                        IDC_ACTIONMENU
+  POPUP "Action"
+  BEGIN
+    MENUITEM "Scan for hardware changes",   IDC_SCAN_HARDWARE
+    MENUITEM "Add hardware",                IDC_ADD_HARDWARE
+  END
   POPUP "View"
   BEGIN
     MENUITEM "Devices by type",             IDC_DEVBYTYPE
Index: dll/win32/devmgr/lang/pt-BR.rc
===================================================================
--- dll/win32/devmgr/lang/pt-BR.rc	(revision 73580)
+++ dll/win32/devmgr/lang/pt-BR.rc	(working copy)
@@ -251,7 +251,11 @@
   BEGIN
     MENUITEM "E&xit",                       IDC_EXIT
   END
-  MENUITEM "Action",                        IDC_ACTIONMENU
+  POPUP "Action"
+  BEGIN
+    MENUITEM "Scan for hardware changes",   IDC_SCAN_HARDWARE
+    MENUITEM "Add hardware",                IDC_ADD_HARDWARE
+  END
   POPUP "View"
   BEGIN
     MENUITEM "Devices by type",             IDC_DEVBYTYPE
Index: dll/win32/devmgr/lang/ru-RU.rc
===================================================================
--- dll/win32/devmgr/lang/ru-RU.rc	(revision 73580)
+++ dll/win32/devmgr/lang/ru-RU.rc	(working copy)
@@ -250,7 +250,11 @@
   BEGIN
     MENUITEM "В&ыход",                       IDC_EXIT
   END
-  MENUITEM "&Действие",                      IDC_ACTIONMENU
+  POPUP "&Действие"
+  BEGIN
+    MENUITEM "О&бновить конфигурацию оборудования", IDC_SCAN_HARDWARE
+    MENUITEM "&Добавить устройство",                IDC_ADD_HARDWARE
+  END
   POPUP "&Вид"
   BEGIN
     MENUITEM "&Устройства по типу",          IDC_DEVBYTYPE
Index: dll/win32/devmgr/lang/sk-SK.rc
===================================================================
--- dll/win32/devmgr/lang/sk-SK.rc	(revision 73580)
+++ dll/win32/devmgr/lang/sk-SK.rc	(working copy)
@@ -253,7 +253,11 @@
   BEGIN
     MENUITEM "E&xit",                       IDC_EXIT
   END
-  MENUITEM "Action",                        IDC_ACTIONMENU
+  POPUP "Action"
+  BEGIN
+    MENUITEM "Scan for hardware changes",   IDC_SCAN_HARDWARE
+    MENUITEM "Add hardware",                IDC_ADD_HARDWARE
+  END
   POPUP "View"
   BEGIN
     MENUITEM "Devices by type",             IDC_DEVBYTYPE
Index: dll/win32/devmgr/lang/sq-AL.rc
===================================================================
--- dll/win32/devmgr/lang/sq-AL.rc	(revision 73580)
+++ dll/win32/devmgr/lang/sq-AL.rc	(working copy)
@@ -252,7 +252,11 @@
   BEGIN
     MENUITEM "E&xit",                       IDC_EXIT
   END
-  MENUITEM "Action",                        IDC_ACTIONMENU
+  POPUP "Action"
+  BEGIN
+    MENUITEM "Scan for hardware changes",   IDC_SCAN_HARDWARE
+    MENUITEM "Add hardware",                IDC_ADD_HARDWARE
+  END
   POPUP "View"
   BEGIN
     MENUITEM "Devices by type",             IDC_DEVBYTYPE
Index: dll/win32/devmgr/lang/tr-TR.rc
===================================================================
--- dll/win32/devmgr/lang/tr-TR.rc	(revision 73580)
+++ dll/win32/devmgr/lang/tr-TR.rc	(working copy)
@@ -250,7 +250,11 @@
   BEGIN
     MENUITEM "&Çıkış",                      IDC_EXIT
   END
-  MENUITEM "&Eylem",                        IDC_ACTIONMENU
+  POPUP "&Eylem"
+  BEGIN
+    MENUITEM "Donanım Değişiklikleri İçin Tara",  IDC_SCAN_HARDWARE
+    MENUITEM "Donanım Ekle",                      IDC_ADD_HARDWARE
+  END
   POPUP "&Görünüm"
   BEGIN
     MENUITEM "&Türe Göre Aygıtlar",         IDC_DEVBYTYPE
Index: dll/win32/devmgr/lang/uk-UA.rc
===================================================================
--- dll/win32/devmgr/lang/uk-UA.rc	(revision 73580)
+++ dll/win32/devmgr/lang/uk-UA.rc	(working copy)
@@ -256,7 +256,11 @@
   BEGIN
     MENUITEM "E&xit",                       IDC_EXIT
   END
-  MENUITEM "Action",                        IDC_ACTIONMENU
+  POPUP "Action"
+  BEGIN
+    MENUITEM "Scan for hardware changes",   IDC_SCAN_HARDWARE
+    MENUITEM "Add hardware",                IDC_ADD_HARDWARE
+  END
   POPUP "View"
   BEGIN
     MENUITEM "Devices by type",             IDC_DEVBYTYPE
Index: dll/win32/devmgr/lang/zh-CN.rc
===================================================================
--- dll/win32/devmgr/lang/zh-CN.rc	(revision 73580)
+++ dll/win32/devmgr/lang/zh-CN.rc	(working copy)
@@ -249,7 +249,11 @@
   BEGIN
     MENUITEM "关闭(&X)",                       IDC_EXIT
   END
-  MENUITEM "行动",                        IDC_ACTIONMENU
+  POPUP "行动"
+  BEGIN
+    MENUITEM "扫描检测硬件改动",      IDC_SCAN_HARDWARE
+    MENUITEM "添加硬件",             IDC_ADD_HARDWARE
+  END
   POPUP "视图"
   BEGIN
     MENUITEM "按类型设备",             IDC_DEVBYTYPE
Index: dll/win32/devmgr/lang/zh-TW.rc
===================================================================
--- dll/win32/devmgr/lang/zh-TW.rc	(revision 73580)
+++ dll/win32/devmgr/lang/zh-TW.rc	(working copy)
@@ -249,7 +249,11 @@
   BEGIN
     MENUITEM "關閉(&X)",                       IDC_EXIT
   END
-  MENUITEM "行動",                        IDC_ACTIONMENU
+  POPUP "行動"
+  BEGIN
+    MENUITEM "掃描檢測硬體改動",                 IDC_SCAN_HARDWARE
+    MENUITEM "添加硬體",                        IDC_ADD_HARDWARE
+  END
   POPUP "檢視"
   BEGIN
     MENUITEM "按類型裝置",             IDC_DEVBYTYPE