Index: dll/win32/kernel32/winnls/nls/moc.nls
===================================================================
--- dll/win32/kernel32/winnls/nls/moc.nls	(nonexistent)
+++ dll/win32/kernel32/winnls/nls/moc.nls	(working copy)
@@ -0,0 +1,158 @@
+/*
+ * Locale definitions for Moldovan (Cyrillic)
+ *
+ * With love from cybernenea11 (cybernenea11 [at] yandex [dot] com) for ReactOS
+ *
+ * This library is free software; you can redistribute it and/or
+ * modify it under the terms of the GNU Lesser General Public
+ * License as published by the Free Software Foundation; either
+ * version 2.1 of the License, or (at your option) any later version.
+ *
+ * This library is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+ * Lesser General Public License for more details.
+ *
+ * You should have received a copy of the GNU Lesser General Public
+ * License along with this library; if not, write to the Free Software
+ * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301, USA
+ */
+
+#pragma code_page(65001)
+
+STRINGTABLE LANGUAGE LANG_MOLDOVAN, SUBLANG_MOLDOVAN_CYRILLIC
+{
+  LOCALE_FONTSIGNATURE L"\x0203\x8000\x3848\x0000\x0000\x0000\x0000\x0000\x0004\x0000\x0000\x0002\x0004\x0000\x0000\x0202"
+  LOCALE_ICALENDARTYPE "1"
+  LOCALE_ICENTURY "1"
+  LOCALE_ICOUNTRY "373"
+  LOCALE_ICURRDIGITS "2"
+  LOCALE_ICURRENCY "3"
+  LOCALE_IDATE "1"
+  LOCALE_IDAYLZERO "1"
+  LOCALE_IDEFAULTANSICODEPAGE "1251"
+  LOCALE_IDEFAULTCODEPAGE "866"
+  LOCALE_IDEFAULTCOUNTRY "373"
+  LOCALE_IDEFAULTEBCDICCODEPAGE "20880"
+  LOCALE_IDEFAULTLANGUAGE "047b"
+  LOCALE_IDEFAULTMACCODEPAGE "10007"
+  LOCALE_IDEFAULTUNIXCODEPAGE "28595"
+  LOCALE_IDIGITS "2"
+  LOCALE_IDIGITSUBSTITUTION "1"
+  LOCALE_IFIRSTDAYOFWEEK "0"
+  LOCALE_IFIRSTWEEKOFYEAR "0"
+  LOCALE_IINTLCURRDIGITS "2"
+  LOCALE_ILANGUAGE "047b"
+  LOCALE_ILDATE "1"
+  LOCALE_ILZERO "1"
+  LOCALE_IMEASURE "0"
+  LOCALE_IMONLZERO "1"
+  LOCALE_INEGCURR "8"
+  LOCALE_INEGNUMBER "1"
+  LOCALE_INEGSEPBYSPACE "0"
+  LOCALE_INEGSIGNPOSN "1"
+  LOCALE_INEGSYMPRECEDES "0"
+  LOCALE_INEUTRAL "0"
+  LOCALE_IOPTIONALCALENDAR "0"
+  LOCALE_IPAPERSIZE "9"
+  LOCALE_IPOSSEPBYSPACE "0"
+  LOCALE_IPOSSIGNPOSN "1"
+  LOCALE_IPOSSYMPRECEDES "0"
+  LOCALE_IREADINGLAYOUT "0"
+  LOCALE_ITIME "1"
+  LOCALE_ITIMEMARKPOSN "0"
+  LOCALE_ITLZERO "0"
+  LOCALE_S1159 ""
+  LOCALE_S2359 ""
+  LOCALE_SABBREVCTRYNAME "MDA"
+  LOCALE_SABBREVDAYNAME1 "Лу"
+  LOCALE_SABBREVDAYNAME2 "Ма"
+  LOCALE_SABBREVDAYNAME3 "Ме"
+  LOCALE_SABBREVDAYNAME4 "Жо"
+  LOCALE_SABBREVDAYNAME5 "Ви"
+  LOCALE_SABBREVDAYNAME6 "Сы"
+  LOCALE_SABBREVDAYNAME7 "Ду"
+  LOCALE_SABBREVLANGNAME "MOL"
+  LOCALE_SABBREVMONTHNAME1 "яну"
+  LOCALE_SABBREVMONTHNAME2 "феб"
+  LOCALE_SABBREVMONTHNAME3 "мар"
+  LOCALE_SABBREVMONTHNAME4 "апр"
+  LOCALE_SABBREVMONTHNAME5 "май"
+  LOCALE_SABBREVMONTHNAME6 "юни"
+  LOCALE_SABBREVMONTHNAME7 "юли"
+  LOCALE_SABBREVMONTHNAME8 "ауг"
+  LOCALE_SABBREVMONTHNAME9 "сеп"
+  LOCALE_SABBREVMONTHNAME10 "окт"
+  LOCALE_SABBREVMONTHNAME11 "ное"
+  LOCALE_SABBREVMONTHNAME12 "деч"
+  LOCALE_SABBREVMONTHNAME13 ""
+  LOCALE_SCOUNTRY "Moldova"
+  LOCALE_SCURRENCY "лей"
+  LOCALE_SDATE "."
+  LOCALE_SDAYNAME1 "лунь"
+  LOCALE_SDAYNAME2 "марць"
+  LOCALE_SDAYNAME3 "меркурь"
+  LOCALE_SDAYNAME4 "жой"
+  LOCALE_SDAYNAME5 "винерь"
+  LOCALE_SDAYNAME6 "сымбэтэ"
+  LOCALE_SDAYNAME7 "думиникэ"
+  LOCALE_SDECIMAL ","
+  LOCALE_SENGCOUNTRY "Moldova"
+  LOCALE_SENGCURRNAME "Moldovan Leu"
+  LOCALE_SENGLANGUAGE "Moldovan (Cyrillic)"
+  LOCALE_SGROUPING "3;0"
+  LOCALE_SINTLSYMBOL "MDL"
+  LOCALE_SISO3166CTRYNAME "MD"
+  LOCALE_SISO639LANGNAME "mo"
+  LOCALE_SLANGUAGE "Moldovan (Cyrillic)"
+  LOCALE_SLIST ";"
+  LOCALE_SLONGDATE "d MMMM yyyy"
+  LOCALE_SMONDECIMALSEP ","
+  LOCALE_SMONGROUPING "3;0"
+  LOCALE_SMONTHNAME1 "януарие"
+  LOCALE_SMONTHNAME2 "фебруарие"
+  LOCALE_SMONTHNAME3 "мартие"
+  LOCALE_SMONTHNAME4 "априлие"
+  LOCALE_SMONTHNAME5 "май"
+  LOCALE_SMONTHNAME6 "юние"
+  LOCALE_SMONTHNAME7 "юлие"
+  LOCALE_SMONTHNAME8 "аугуст"
+  LOCALE_SMONTHNAME9 "септембрие"
+  LOCALE_SMONTHNAME10 "октомбрие"
+  LOCALE_SMONTHNAME11 "ноембрие"
+  LOCALE_SMONTHNAME12 "дечембрие"
+  LOCALE_SMONTHNAME13 ""
+  LOCALE_SMONTHOUSANDSEP "."
+  LOCALE_SNAME "mo-Cyrl-MD"
+  LOCALE_SNATIVECTRYNAME "Молдова"
+  LOCALE_SNATIVECURRNAME "Леу"
+  LOCALE_SNATIVEDIGITS "0123456789"
+  LOCALE_SNATIVELANGNAME "молдовеняскэ"
+  LOCALE_SNEGATIVESIGN "-"
+  LOCALE_SPOSITIVESIGN ""
+  LOCALE_SSCRIPTS "Cyrl;"
+  LOCALE_SSHORTDATE "dd.MM.yyyy"
+  LOCALE_SSORTNAME "Default"
+  LOCALE_STHOUSAND " "
+  LOCALE_STIME ":"
+  LOCALE_STIMEFORMAT "H:mm:ss"
+  LOCALE_SYEARMONTH "MMMM yyyy"
+
+  LGRPID_WESTERN_EUROPE+LGRPID_RES_BASE "Еуропа де Вест ши Стателе Уните"
+  LGRPID_CENTRAL_EUROPE+LGRPID_RES_BASE "Еуропа Чентралэ"
+  LGRPID_BALTIC+LGRPID_RES_BASE "Балтик"
+  LGRPID_GREEK+LGRPID_RES_BASE "Греческ"
+  LGRPID_CYRILLIC+LGRPID_RES_BASE "Кирилик"
+  LGRPID_TURKISH+LGRPID_RES_BASE "Турческ"
+  LGRPID_JAPANESE+LGRPID_RES_BASE "Жапонез"
+  LGRPID_KOREAN+LGRPID_RES_BASE "Кореян"
+  LGRPID_TRADITIONAL_CHINESE+LGRPID_RES_BASE "Кинезеск традиционал"
+  LGRPID_SIMPLIFIED_CHINESE+LGRPID_RES_BASE "Кинезеск симплификат"
+  LGRPID_THAI+LGRPID_RES_BASE "Тайландез"
+  LGRPID_HEBREW+LGRPID_RES_BASE "Ебраик"
+  LGRPID_ARABIC+LGRPID_RES_BASE "Араб"
+  LGRPID_VIETNAMESE+LGRPID_RES_BASE "Виетнамез"
+  LGRPID_INDIC+LGRPID_RES_BASE "Индиан"
+  LGRPID_GEORGIAN+LGRPID_RES_BASE "Ӂеорӂиан"
+  LGRPID_ARMENIAN+LGRPID_RES_BASE "Армян"
+}