Index: win32ss/user/ntuser/display.c
===================================================================
--- win32ss/user/ntuser/display.c	(revision 74519)
+++ win32ss/user/ntuser/display.c	(working copy)
@@ -697,6 +697,8 @@
     HKEY hkey;
     NTSTATUS Status;
     PPDEVOBJ ppdev;
+    WORD OrigBC;
+    DWORD dwFields;
     //PDESKTOP pdesk;
 
     /* If no DEVMODE is given, use registry settings */
@@ -715,6 +717,9 @@
     else
         dm = *pdm;
 
+    /* Save original bit count */
+    OrigBC = gpsi->BitCount;
+
     /* Check params */
     if ((dm.dmFields & (DM_PELSWIDTH | DM_PELSHEIGHT)) != (DM_PELSWIDTH | DM_PELSHEIGHT))
     {
@@ -775,10 +780,20 @@
         }
     }
 
+    /* Compare asked DEVMODE fields
+     * Only compare those that are valid in both DEVMODE structs */
+    dwFields = ppdev->pdmwDev->dmFields & pdm->dmFields;
+
     /* Check if DEVMODE matches the current mode */
-    if (pdm == ppdev->pdmwDev && !(flags & CDS_RESET))
+    if ( pdm == ppdev->pdmwDev && !(flags & CDS_RESET)  &&
+         ( (dwFields & DM_BITSPERPEL) &&
+           (ppdev->gdiinfo.cBitsPixel == pdm->dmBitsPerPel) ) &&
+         ( (dwFields & DM_PELSWIDTH)  &&
+           (ppdev->gdiinfo.ulHorzRes  == pdm->dmPelsWidth)  ) &&
+         ( (dwFields & DM_PELSHEIGHT) &&
+           (ppdev->gdiinfo.ulVertRes  == pdm->dmPelsHeight) ) )
     {
-        ERR("DEVMODE matches, nothing to do\n");
+        ERR("DEVMODE matches, nothing to do BC Old %d OldChk %d pdm dmBitsPerPel %d\n",gpsi->BitCount,ppdev->gdiinfo.cBitsPixel,pdm->dmBitsPerPel);
         goto leave;
     }
 
@@ -787,6 +802,7 @@
     {
         ULONG ulResult;
         PVOID pvOldCursor;
+        TEXTMETRICW tmw;
 
         /* Remove mouse pointer */
         pvOldCursor = UserSetCursor(NULL, TRUE);
@@ -813,11 +829,24 @@
         /* Update the system metrics */
         InitMetrics();
 
-        //IntvGetDeviceCaps(&PrimarySurface, &GdiHandleTable->DevCaps);
-
         /* Set new size of the monitor */
         UserUpdateMonitorSize((HDEV)ppdev);
 
+        /* Update the SERVERINFO */
+        gpsi->dmLogPixels = ppdev->gdiinfo.ulLogPixelsY;
+        gpsi->Planes      = ppdev->gdiinfo.cPlanes;
+        gpsi->BitsPixel   = ppdev->gdiinfo.cBitsPixel;
+        gpsi->BitCount    = gpsi->Planes * gpsi->BitsPixel;
+        if (ppdev->gdiinfo.flRaster & RC_PALETTE)
+        {
+            gpsi->PUSIFlags |= PUSIF_PALETTEDISPLAY;
+        }
+        else
+            gpsi->PUSIFlags &= ~PUSIF_PALETTEDISPLAY;
+        // Font is realized and this dc was previously set to internal DC_ATTR.
+        gpsi->cxSysFontChar = IntGetCharDimensions(hSystemBM, &tmw, (DWORD*)&gpsi->cySysFontChar);
+        gpsi->tmSysFont     = tmw;
+
         /* Remove all cursor clipping */
         UserClipCursor(NULL);
 
@@ -825,14 +854,22 @@
         //IntHideDesktop(pdesk);
 
         /* Send WM_DISPLAYCHANGE to all toplevel windows */
-        co_IntSendMessageTimeout(HWND_BROADCAST,
-                                 WM_DISPLAYCHANGE,
-                                 (WPARAM)ppdev->gdiinfo.cBitsPixel,
-                                 (LPARAM)(ppdev->gdiinfo.ulHorzRes + (ppdev->gdiinfo.ulVertRes << 16)),
-                                 SMTO_NORMAL,
-                                 100,
-                                 &ulResult);
+        UserSendNotifyMessage( HWND_BROADCAST,
+                               WM_DISPLAYCHANGE,
+                               gpsi->BitCount,
+                               MAKELONG(gpsi->aiSysMet[SM_CXSCREEN], gpsi->aiSysMet[SM_CYSCREEN]) );
 
+        ERR("BitCount New %d Orig %d ChkNew %d\n",gpsi->BitCount,OrigBC,ppdev->gdiinfo.cBitsPixel);
+
+        /* Not full screen and different bit count, send messages */
+        if (!(flags & CDS_FULLSCREEN) &&
+              gpsi->BitCount != OrigBC )
+        {
+           ERR("Detect settings changed.\n");
+           UserSendNotifyMessage( HWND_BROADCAST, WM_SETTINGCHANGE, 0, 0 );
+           UserSendNotifyMessage( HWND_BROADCAST, WM_SYSCOLORCHANGE, 0, 0 );
+        }
+
         //co_IntShowDesktop(pdesk, ppdev->gdiinfo.ulHorzRes, ppdev->gdiinfo.ulVertRes);
 
         UserRedrawDesktop();
Index: win32ss/user/ntuser/monitor.c
===================================================================
--- win32ss/user/ntuser/monitor.c	(revision 74519)
+++ win32ss/user/ntuser/monitor.c	(working copy)
@@ -266,6 +266,11 @@
     if (pMonitor->hrgnMonitor)
         IntGdiSetRegionOwner(pMonitor->hrgnMonitor, GDI_OBJ_HMGR_PUBLIC);
 
+    //
+    // Should be Virtual accumulation of all the available monitors.
+    //
+    gpsi->rcScreenReal = pMonitor->rcMonitor;
+
     return STATUS_SUCCESS;
 }
 